# 1 "ira_regression.c"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "ira_regression.c"
# 1 "/home/hariharans5/RelTools/bin/../lib/gcc/picochip-unknown-none/4.4.0/include/picochip.h" 1 3 4
# 20 "/home/hariharans5/RelTools/bin/../lib/gcc/picochip-unknown-none/4.4.0/include/picochip.h" 3 4
typedef signed short integer;
typedef signed char integer8;
typedef signed short integer16;
typedef signed long integer32;
typedef signed long long integer64;


typedef struct complex8 {
  integer8 re, im;
} complex8;

typedef struct integer16pair {
  integer16 el1;
  integer16 el2;
} integer16pair;

typedef struct integer8quad {
  integer8 el1;
  integer8 el2;
  integer8 el3;
  integer8 el4;
} integer8quad;

typedef struct complex16 {
  integer16 re;
  integer16 im;
} complex16;

typedef struct complex8pair {
  complex8 el1;
  complex8 el2;
} complex8pair;

typedef struct integer8pair_complex8 {
  integer8 el1;
  integer8 el2;
  complex8 el3;
} integer8pair_complex8;

typedef struct integer16_complex8 {
  integer16 el1;
  complex8 el2;
} integer16_complex8;

typedef struct integer16_integer8pair {
  integer16 el1;
  integer8 el2;
  integer8 el3;
} integer16_integer8pair;

typedef struct complex32 {
  integer32 re;
  integer32 im;
} complex32;

typedef struct complex64 {
  integer64 re;
  integer64 im;
} complex64;






int picoSbc (int value);
unsigned int picoByteSwap (unsigned int value);
unsigned int picoBrev (unsigned int value);
int picoAdds (int x, int y);
int picoSubs (int x, int y);
void picoHalt (void) __attribute__ ((__noreturn__));
int picoClz32 (unsigned long value);



int __builtin_testport (int);
long __builtin_get (int);
void __builtin_put (int, long);
void __builtin_put_array (long, int, int, int);
long __builtin_get_array (int, int, int);
int __builtin_testport_array (int, int, int);
# 2 "ira_regression.c" 2

static inline integer16pair getsfnHccIn(void) __attribute__((always_inline));
static inline integer16pair getsfnHccIn(void) {
 union{integer16pair actualValue; long rawValue; } converter;
 converter.rawValue = __builtin_get(2);
 return converter.actualValue;
}

static inline void putphyCtrlDlOut(integer32 value) __attribute__((always_inline));
static inline void putphyCtrlDlOut(integer32 value) {
 value = value;
 __builtin_put(5, value);
}

static inline integer32 getphyCtrlUlIn(void) __attribute__((always_inline));
static inline integer32 getphyCtrlUlIn(void) {
long value;
 value = __builtin_get(6);
 return value;
}

static inline void putphyCtrlUlOut(integer32 value) __attribute__((always_inline));
static inline void putphyCtrlUlOut(integer32 value) {
 value = value;
 __builtin_put(7, value);
}

typedef signed char int8_t;
typedef int int16_t;
typedef long int32_t;
typedef long long int64_t;

typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long uint32_t;
typedef unsigned long long uint64_t;



typedef signed char int_least8_t;
typedef int int_least16_t;
typedef long int_least32_t;
typedef long long int_least64_t;

typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef int int_fast8_t;
typedef int int_fast16_t;
typedef long int_fast32_t;
typedef long long int_fast64_t;

typedef unsigned int uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long uint_fast32_t;
typedef unsigned long long uint_fast64_t;







typedef int64_t intmax_t;
typedef uint64_t uintmax_t;
    uint16_t spiWrite(uint32_t spiData, uint16_t spiDataWidth, uint16_t spiPort, uint16_t currentSpiGpioDataState);






typedef int ptrdiff_t;
typedef unsigned int size_t;
typedef short unsigned int wchar_t;

typedef unsigned long long U64;
typedef unsigned long U32;
typedef unsigned short U16;
typedef short S16;
typedef long S32;
typedef signed char S8;
typedef unsigned char U8;
typedef _Bool BOOL;
typedef enum
{
NORMAL = 0,
MODIFY = 1
}ackFifoCtrl_t;

 uint16_t radioFifoInPtr, radioFifoOutPtr, radioFifoLvl;
 uint32_t ackFifo [((32*2)+4)*2];
 uint16_t ackFifoInPtr, ackFifoOutPtr, ackFifoLvl;

 uint32_t getRadioFifo (void);
 void putAckFifo (ackFifoCtrl_t fifoModify, uint16_t fifoIndex, uint32_t fifoData);


typedef enum
{
HEADER,
ENTRIES,
FOOTER
}stateRse_t;

typedef enum
{
OK,
STATEDEFAULT,
HEADEREXPECTED,
FOOTEREXPECTED,
SPI0FAIL,
SPI1FAIL,
SPI2FAIL,
AGCFAIL,
GAINFAIL,
DCFAIL,
SEQLEN
}actionError_t;
stateRse_t actionState;
uint16_t currentAckSeqTop;
uint16_t currentRadioSeqLen;
uint16_t currentAckSeqLen;
_Bool matchTimeStamp;
uint32_t currentCmdHcc;
uint16_t currentCmdSfn;
uint16_t spiDataWidth;
uint16_t spiGpioMask;
uint16_t currentSpiGpioDataState;
uint16_t currentSpiGpioCtrlState;
uint16_t currentSequenceId;
uint32_t fifoTemp;
integer16pair sfnHcc;
uint16_t completeSeqInRadioFifo;
actionError_t radioSeqError;
uint16_t localSfn;
uint16_t localHcc;
uint16_t ackFifoDepth;
_Bool radioSeqToAction;


actionError_t processCmdPayload (uint32_t radioCmd)
{
 actionError_t error = OK;
 uint32_t fifoData;
 uint32_t temp32, temp32b;
 integer16pair portSfnHcc;

 switch (radioCmd)
 {

  case 0x00000001:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   if ((spiGpioMask & 0x000E) == 0)
   {
    currentSpiGpioDataState = spiWrite(fifoData, spiDataWidth, 0x000E & 0x0038, currentSpiGpioDataState);
    error = OK;
   }
   else
   {
    error = SPI0FAIL;
   }

   break;




  case 0x00000002:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   if ((spiGpioMask & 0x0016) == 0)
   {
    currentSpiGpioDataState = spiWrite(fifoData, spiDataWidth, 0x0016 & 0x0038, currentSpiGpioDataState);
    error = OK;
   }
   else
   {
    error = SPI1FAIL;
   }

   break;




  case 0x00000003:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   if ((spiGpioMask & 0x0026) == 0)
   {
    currentSpiGpioDataState = spiWrite(fifoData, spiDataWidth, 0x0026 & 0x0038, currentSpiGpioDataState);
    error = OK;
   }
   else
   {
    error = SPI2FAIL;
   }

   break;




  case 0x00010001:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x00800000;
   putphyCtrlUlOut(fifoData);

   break;




  case 0x00010002:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00000000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00000000)
   {
    putAckFifo (NORMAL, 0, 0x00010002);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }

   break;




  case 0x00010003:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x00840000;
   putphyCtrlUlOut(fifoData);

   break;




  case 0x00010004:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00040000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00040000)
   {
    putAckFifo (NORMAL, 0, 0x00010004);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }

   break;




  case 0x00010005:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x00860000;
   putphyCtrlUlOut(fifoData);

   break;




  case 0x00010006:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00060000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00060000)
   {
    putAckFifo (NORMAL, 0, 0x00010006);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }

   break;





  case 0x00010007:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00080000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00080000)
   {
    temp32 = fifoData & 0x0000FFFF;
   }
   else
   {
    error = AGCFAIL;
    break;
   }

   fifoData = 0x000A0000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x000A0000)
   {
    temp32 = (fifoData << 16) + temp32;
    putAckFifo (NORMAL, 0, 0x00010007);
    putAckFifo (NORMAL, 0, temp32);
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }

   break;





  case 0x00010008:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00140000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00140000)
   {
    temp32 = fifoData & 0x0000FFFF;
   }
   else
   {
    error = AGCFAIL;
    break;
   }

   fifoData = 0x00160000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00160000)
   {
    temp32 = (fifoData << 16) + temp32;
    putAckFifo (NORMAL, 0, 0x00010008);
    putAckFifo (NORMAL, 0, temp32);
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }
   break;





  case 0x00010009:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   temp32 = (fifoData & 0x0000FFFF) + 0x00900000;
   putphyCtrlUlOut(temp32);

   temp32 = (fifoData >> 16) + 0x00920000;
   putphyCtrlUlOut(temp32);

   break;





  case 0x0001000A:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00100000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00100000)
   {
    temp32 = fifoData & 0x0000FFFF;
   }
   else
   {
    error = AGCFAIL;
    break;
   }

   fifoData = 0x00120000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00120000)
   {
    temp32 = (fifoData << 16) + temp32;
    putAckFifo (NORMAL, 0, 0x0001000A);
    putAckFifo (NORMAL, 0, temp32);
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }
   break;





  case 0x0001000B:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x000C0000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x000C0000)
   {
    temp32 = fifoData & 0x0000FFFF;
   }
   else
   {
    error = AGCFAIL;
    break;
   }

   fifoData = 0x000E0000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x000E0000)
   {
    temp32 = (fifoData << 16) + temp32;
    putAckFifo (NORMAL, 0, 0x0001000B);
    putAckFifo (NORMAL, 0, temp32);
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }
   break;





  case 0x0001000C:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   temp32 = (fifoData & 0x00000007) + 0x00980000;
   putphyCtrlUlOut(temp32);

   temp32 = ((fifoData & 0x00000038) >> 3) + 0x009A0000;
   putphyCtrlUlOut(temp32);

   temp32 = ((fifoData & 0x000001C0) >> 6) + 0x009C0000;
   putphyCtrlUlOut(temp32);

   break;





  case 0x0001000D:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x00180000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x00180000)
   {
    temp32 = fifoData & 0x00000007;
   }
   else
   {
    error = AGCFAIL;
    break;
   }

   fifoData = 0x001A0000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x001A0000)
   {
    temp32 = ((fifoData & 0x00000007) << 3) + temp32;
   }
   else
   {
    error = AGCFAIL;
    break;
   }

   fifoData = 0x001C0000;
   putphyCtrlUlOut(fifoData);
   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x001C0000)
   {
    temp32 = ((fifoData & 0x00000007) << 6) + temp32;
    putAckFifo (NORMAL, 0, 0x0001000D);
    putAckFifo (NORMAL, 0, temp32);
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }
   break;




  case 0x0001000E:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x009E0000;
   putphyCtrlUlOut(fifoData);

   break;




  case 0x0001000F:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x001E0000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x001E0000)
   {
    putAckFifo (NORMAL, 0, 0x0001000F);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = AGCFAIL;
   }
   break;




  case 0x00010010:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x06000000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x06000000)
   {
    putAckFifo (NORMAL, 0, 0x00010010);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = GAINFAIL;
   }

   break;




  case 0x00010011:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x06010000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x06010000)
   {
    putAckFifo (NORMAL, 0, 0x00010011);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = GAINFAIL;
   }

   break;




  case 0x00010012:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x06820000;
   putphyCtrlUlOut(fifoData);

   break;




  case 0x00010013:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x06020000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x06020000)
   {
    putAckFifo (NORMAL, 0, 0x00010013);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = GAINFAIL;
   }

   break;




  case 0x00010014:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x06830000;
   putphyCtrlUlOut(fifoData);

   break;




  case 0x00010015:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = 0x06030000;
   putphyCtrlUlOut(fifoData);

   fifoData = getphyCtrlUlIn();

   if ((fifoData & 0xFFFF0000) == 0x06030000)
   {
    putAckFifo (NORMAL, 0, 0x00010015);
    putAckFifo (NORMAL, 0, (fifoData & 0x0000FFFF));
    currentAckSeqLen += 2;
   }
   else
   {
    error = GAINFAIL;
   }

   break;




  case 0x00001001:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x04840000;
   putphyCtrlUlOut(fifoData);

   break;





  case 0x00001003:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   temp32 = (fifoData & 0x0000FFFF) + 0x02840000;
   putphyCtrlUlOut(temp32);

   temp32 = (fifoData >> 16) + 0x02850000;
   putphyCtrlUlOut(temp32);

   break;




  case 0x00001004:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x02860000;
   putphyCtrlUlOut(fifoData);

   break;






  case 0x00100001:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   portSfnHcc = getsfnHccIn();
   temp32 = (portSfnHcc.el2 & 0xFFF0);
   temp32 = temp32 << 13;
   temp32b = portSfnHcc.el1 & 0x0000FFFF;

   if (portSfnHcc.el2 & 0x0001)
   {
    fifoData = temp32b + 0x00010000 + temp32;
   }
   else
   {
    fifoData = temp32b + temp32;
   }

   putAckFifo (NORMAL, 0, 0x00100001);
   putAckFifo (NORMAL, 0, fifoData);
   currentAckSeqLen += 2;

   break;




  case 0x00100003:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;


   spiDataWidth = fifoData & 0x0000001F;
   break;




  case 0x00000101:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x00800000;
   putphyCtrlDlOut(fifoData);

   break;





  case 0x00000102:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   temp32 = (fifoData & 0x0000FFFF) + 0x00810000;
   putphyCtrlDlOut(temp32);

   temp32 = (fifoData >> 16) + 0x00820000;
   putphyCtrlDlOut(temp32);

   break;




  case 0x00000103:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   fifoData = fifoData + 0x02820000;
   putphyCtrlDlOut(fifoData);

   break;





  case 0x00000104:
   fifoData = getRadioFifo();
   currentRadioSeqLen -= 1;

   temp32 = (fifoData & 0x0000FFFF) + 0x02800000;
   putphyCtrlDlOut(temp32);

   temp32 = (fifoData >> 16) + 0x02810000;
   putphyCtrlDlOut(temp32);

   break;


  default:
   error = STATEDEFAULT;
   break;
 }

 return error;

}
